#include <SPI.h>
 #include <SD.h>
 const int PIN = 4;
 
 #include <LiquidCrystal.h>
 constexpr uint8_t PIN_RS = 6;
 constexpr uint8_t PIN_EN = 5;
 constexpr uint8_t PIN_DB4 = 4;
 constexpr uint8_t PIN_DB5 = 3;
 constexpr uint8_t PIN_DB6 = 2;
 constexpr uint8_t PIN_DB7 = 14;    
 LiquidCrystal lcd(61,62,63,64,65,66);
     
 int vniz = 16;  //  
 int vibrati = 17;  //  
 int vverh = 18; //  
 int Vverh = 0; //  
 int Vniz = 0;
 int Vibrati = 0;
 int programma = 0;
 int Dinamik = 15; //  
 int C = 54; // 
 int D = 55;
 int E = 56;
 int F = 57;
 int G = 58;
 int A = 59;
 int B = 60;
 int c = 0; //  
 int d = 0;
 int e = 0;
 int f = 0;
 int g = 0;
 int a = 0;
 int b = 0;
 int z = 0;
 int Random = 0;
 int Otvet = 7;
 int nota[] = {0,131,148,165,175,196,220,247}; //   
 int zagatayaKnopka[100]; //    
 char nugnayaNota = 0; 
 int vremya[100]; //   
 char ms = 0;
 unsigned long dlina = 0;
 unsigned long Vremya = 0;
 int nt = 0;
 int dl = 0;
 int Time[] = {3,2,1,0}; //  
 String Programma[] = {"\xA9\x70\x6F\xBA    ","\xA4\x61\xC0\xB5\xBF   ","\xA4\x61\xBE\xB8\x63\xC4  ","\xA8\x70\x6F\xB8\xB7\xB3\x6F\xBB","        "}; //  
 String DoRe[] = {"C - Do  ","D - Re  ","E - Mi  ","F - Fa  ","G - Soli","A - Lya ","B - Si  "};
 int Dlina[] = {500,250,125,62,31,16};
 int VR = 0;
 int ZV = 0;
void setup() {
 Serial.begin(9600);
 lcd.begin(16, 2);
 pinMode(Dinamik, OUTPUT);
 for(int i = 54; i < 60; i++){
  pinMode(i, INPUT); 
 }
 for(int i = 16; i < 18; i++){
  pinMode(i, INPUT); 
 }
 pinMode(10, OUTPUT);
 if (!SD.begin(PIN)) {
  return;
 } 
}  
void loop() {
 Vverh = digitalRead(vverh);
 Vniz = digitalRead(vniz);
 Vibrati = digitalRead(vibrati); 
 if(Vverh == HIGH){ //  
  if(programma > 0){
   programma = programma - 1;
   while(Vverh == HIGH){
    Vverh = digitalRead(vverh); 
   } 
  }else{
   while(Vverh == HIGH){
    Vverh = digitalRead(vverh); 
   }
  }
 }
 if(Vniz == HIGH){ //  
  if(programma < 3){
   programma = programma + 1;
   while(Vniz == HIGH){
    Vniz = digitalRead(vniz);  
   }
  }else{
   while(vniz == HIGH){
    Vniz = digitalRead(vniz); 
   }
  }
 }
 if(Vibrati == HIGH){ //  
  lcd.setCursor(0, 0);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print("                ");
  delay(200); 
  lcd.setCursor(0, 0);
  lcd.print("\xA8\x6F\xE3\xB4\x6F\xBF\x6F\xB3\xBA\x61");    
  for(int sek = 0; sek < 4; ++sek){
   for(int mili = 0; mili<1500; ++mili){
    lcd.setCursor(11, 0);
    lcd.print(Time[sek]); 
   }
  }
  lcd.setCursor(0, 0);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print("                ");
  Vibrati = digitalRead(vibrati);
  if(programma == 0){ // 
   while(Vibrati == LOW){
    urok();
    Vibrati = digitalRead(vibrati);
   }
   while(Vibrati == HIGH){
    Vibrati = digitalRead(vibrati);
   }
  }
  if(programma == 1){ // 
   while(Vibrati == LOW){
    ekzamen();
    Vibrati = digitalRead(vibrati);
   }
   while(Vibrati == HIGH){
    Vibrati = digitalRead(vibrati);
   }
  } 
  if(programma == 2){ // 
   while(Vibrati == LOW){
    Zapise();
    Vibrati = digitalRead(vibrati);
   }
   while(Vibrati == HIGH){
    Vibrati = digitalRead(vibrati);
   }
  }
  if(programma == 3){ // 
   while(Vibrati == LOW){
    Sluchay();
    Vibrati = digitalRead(vibrati);
   }
   noTone(Dinamik);
   while(Vibrati == HIGH){
    Vibrati = digitalRead(vibrati);
   }
  }   
 }
  lcd.setCursor(0, 0);
  lcd.print("\x3E\x3E");
  lcd.setCursor(2, 0);
  lcd.print(Programma[programma]);
  lcd.setCursor(2, 1);
  lcd.print(Programma[programma+1]);
}
void Zapise(){
 Vverh = digitalRead(vverh);
 Vibrati = digitalRead(vibrati); 
 if(Vverh == LOW && Vibrati == LOW ){
  c = digitalRead(C);
  d = digitalRead(D);
  e = digitalRead(E);
  f = digitalRead(F);
  g = digitalRead(G);
  a = digitalRead(A);
  b = digitalRead(B);
  if(c == HIGH){
   dlina = millis();
   while(c == HIGH){
    c = digitalRead(C);
    tone(Dinamik,nota[1]);   
   }
   zagatayaKnopka[nugnayaNota] = 1;
   Serial.print("1,");
   File z = SD.open("nota.csv", FILE_WRITE);
   z.println(1);
   z.close();
  }else{
   if(d == HIGH){
   dlina = millis();
   while(d == HIGH){
    d = digitalRead(D);
    tone(Dinamik,nota[2]);   
   }
   zagatayaKnopka[nugnayaNota] = 2;
   Serial.print("2,");
   File z = SD.open("nota.csv", FILE_WRITE);
   z.println(2);
   z.close();
   }else{
    if(e == HIGH){
     dlina = millis();
     while(e == HIGH){
      e = digitalRead(E);
      tone(Dinamik,nota[3]);   
     }
     zagatayaKnopka[nugnayaNota] = 3;
     Serial.print("3,");
     File z = SD.open("nota.csv", FILE_WRITE);
     z.println(3);
     z.close();
    }else{ 
     if(f == HIGH){
     dlina = millis();
     while(f == HIGH){
      f = digitalRead(F);
      tone(Dinamik,nota[4]);   
     }
     zagatayaKnopka[nugnayaNota] = 4;
     Serial.print("4,");
     File z = SD.open("nota.csv", FILE_WRITE);
     z.println(4);
     z.close();
     }else{ 
      if(g == HIGH){
      dlina = millis();
      while(g == HIGH){
       g = digitalRead(G);
       tone(Dinamik,nota[5]);   
      }
      zagatayaKnopka[nugnayaNota] = 5;
      Serial.print("5,");
      File z = SD.open("nota.csv", FILE_WRITE);
      z.println(5);
      z.close();
      }else{ 
       if(a == HIGH){
       dlina = millis();
       while(a == HIGH){
        a = digitalRead(A);
        tone(Dinamik,nota[6]);   
       }
       zagatayaKnopka[nugnayaNota] = 6;
       Serial.print("6,");
       File z = SD.open("nota.csv", FILE_WRITE);
       z.println(6);
       z.close();
       }else{ 
        if(b == HIGH){
        dlina = millis();
        while(b == HIGH){
         b = digitalRead(B);
         tone(Dinamik,nota[7]);   
        }
        zagatayaKnopka[nugnayaNota] = 7;
        Serial.print("7,");
        File z = SD.open("nota.csv", FILE_WRITE);
        z.println(7);
        z.close();
        }else{ 
         dlina = millis();
         Vverh = digitalRead(vverh);
         Vibrati = digitalRead(vibrati); 
         while(c == LOW && d == LOW && e == LOW && f == LOW && g == LOW && a == LOW && b == LOW && Vverh == LOW && Vibrati == LOW){
          c = digitalRead(C);
          d = digitalRead(D);
          e = digitalRead(E);
          f = digitalRead(F);
          g = digitalRead(G);
          a = digitalRead(A);
          b = digitalRead(B);
          Vverh = digitalRead(vverh);
          Vibrati = digitalRead(vibrati); 
          noTone(Dinamik);
          zagatayaKnopka[nugnayaNota] = 0;
          File z = SD.open("nota.csv", FILE_WRITE);
          z.println(0);
          z.close();   
         }
         Serial.print("0,");
        }
       } 
      }
     }
    }
   }
  }                             
  Vremya = millis() - dlina;
  Serial.print(Vremya);
  Serial.print(",");
  vremya[nugnayaNota] = Vremya;
  File p = SD.open("vremya.csv", FILE_WRITE);
  p.println(Vremya);
  p.close();  
  nugnayaNota++;
 }else{
  Serial.println("Vosproizvoghu"); 
  for(int element = 0; element < nugnayaNota; element++){
   if(zagatayaKnopka[element] == 0){
    noTone(Dinamik);
    delay(vremya[element]); 
   }else{
    tone(Dinamik, nota[zagatayaKnopka[element]]);
    delay(vremya[element]);                      
   }   
  }
 }
}
void nagataya_knopka(){
 c = digitalRead(C);
 d = digitalRead(D);
 e = digitalRead(E);
 f = digitalRead(F);
 g = digitalRead(G);
 a = digitalRead(A);
 b = digitalRead(B); 
}
void urok(){
 nagataya_knopka(); 
 if(c == HIGH){
  while(c == HIGH){
   tone(Dinamik, nota[1]);
   c = digitalRead(C);
   lcd.setCursor(0, 0);
   lcd.print("Do");  
  }
  noTone(Dinamik);
  lcd.setCursor(0, 0);
  lcd.print("                ");
 }
 if(d == HIGH){
  while(d == HIGH){
   tone(Dinamik, nota[2]);
   d = digitalRead(D);
   lcd.setCursor(0, 0);
   lcd.print("Re");  
  }
  noTone(Dinamik);
  lcd.setCursor(0, 0);
  lcd.print("                ");
 }
 if(e == HIGH){
  while(e == HIGH){
   tone(Dinamik, nota[3]);
   e = digitalRead(E);
   lcd.setCursor(0, 0);
   lcd.print("Mi");    
  }
  noTone(Dinamik);
  lcd.setCursor(0, 0);
  lcd.print("                ");
 }
 if(f == HIGH){
  while(f == HIGH){
   tone(Dinamik, nota[4]);
   f = digitalRead(F);
   lcd.setCursor(0, 0);
   lcd.print("Fa");    
  }
  noTone(Dinamik);
  lcd.setCursor(0, 0);
  lcd.print("                ");
 }
 if(g == HIGH){
  while(g == HIGH){
   tone(Dinamik, nota[5]);
   g = digitalRead(G);
   lcd.setCursor(0, 0);
   lcd.print("Soli");    
  }
  noTone(Dinamik);
  lcd.setCursor(0, 0);
  lcd.print("                ");
 }
 if(a == HIGH){
  while(a == HIGH){
   tone(Dinamik, nota[6]);
   a = digitalRead(A);
   lcd.setCursor(0, 0);
   lcd.print("Lya");    
  }
  noTone(Dinamik);
  lcd.setCursor(0, 0);
  lcd.print("                ");
 }
 if(b == HIGH){
  while(b == HIGH){
   tone(Dinamik, nota[7]);
   b = digitalRead(B);
   lcd.setCursor(0, 0);
   lcd.print("Si");    
  }
  noTone(Dinamik);
  lcd.setCursor(0, 0);
  lcd.print("                ");
 } 
}
void ekzamen(){
 Random = random(0, 7); 
 Serial.println(Random);
 lcd.setCursor(0, 0);
 lcd.print(DoRe[Random]);
 tone(Dinamik, nota[Random + 1]);
 delay(1000);
 noTone(Dinamik);
 lcd.setCursor(0, 0);
 lcd.print("                ");
 Vibrati = digitalRead(vibrati);   
 while(Otvet == 7 && Vibrati == LOW){
  nagataya_knopka();
  if(c == HIGH){
   Otvet = 0; 
  }
  if(d == HIGH){
   Otvet = 1; 
  }
  if(e == HIGH){
   Otvet = 2; 
  }
  if(f == HIGH){
   Otvet = 3; 
  }
  if(g == HIGH){
   Otvet = 4; 
  }
  if(a == HIGH){
   Otvet = 5; 
  }
  if(b == HIGH){
   Otvet = 6; 
  }
  Vibrati = digitalRead(vibrati);   
 }
 if(Vibrati == LOW){
   if(Otvet == Random){
   lcd.setCursor(0, 0);
   lcd.print("verno");
   tone(Dinamik, nota[Random + 1]);
  }else{
   lcd.setCursor(0, 0);
   lcd.print("neverno");
   tone(Dinamik, 150);
   delay(300);
   tone(Dinamik, 100);
   delay(400);
   noTone(Dinamik);  
  }
  delay(800);
  noTone(Dinamik);
  Otvet = 7;
  lcd.setCursor(0, 0);
  lcd.print("               ");
  delay(1000);  
 } 
}
void Sluchay(){
 ZV = random(0, 9);
 VR = random(0, 6);
 if(ZV == 0){
  noTone(Dinamik);
  delay(Dlina[VR]); 
 }else{
  tone(Dinamik, nota[ZV]);
  delay(Dlina[VR]); 
 }
}